(* ::Package:: *)

convolve[convolvef_,convolveg_,convolvex_]:=
(
convolvew=1/50;convolves=1/20;convolvemn0=4;convolvemn=1/E^(convolvemn0^2/2);(*flag 1\:ff0c2\:ff0c3*)
convolvefI=Re[NIntegrate[convolvef,{convolvex,-\[Infinity],\[Infinity]}]];
convolvegI=Re[NIntegrate[convolveg,{convolvex,-\[Infinity],\[Infinity]}]];
convolve\[Sigma]f=Sqrt[Re[NIntegrate[convolvef*convolvex^2,{convolvex,-\[Infinity],\[Infinity]}]]/convolvefI];
convolve\[Sigma]g=Sqrt[Re[NIntegrate[convolveg*convolvex^2,{convolvex,-\[Infinity],\[Infinity]}]]/convolvegI];
If[convolve\[Sigma]g<convolvew*convolve\[Sigma]f(*1*),
convolveh=(convolvef/.convolvex->convolvex*convolve\[Sigma]f/(convolve\[Sigma]f^2+convolve\[Sigma]g^2)^(1/2))*convolvegI*convolve\[Sigma]f/(convolve\[Sigma]f^2+convolve\[Sigma]g^2)^(1/2),
If[convolve\[Sigma]f<convolvew*convolve\[Sigma]g(*1*),
convolveh=(convolveg/.convolvex->convolvex*convolve\[Sigma]g/(convolve\[Sigma]f^2+convolve\[Sigma]g^2)^(1/2))*convolvefI*convolve\[Sigma]g/(convolve\[Sigma]f^2+convolve\[Sigma]g^2)^(1/2),
convolvestep=convolves*Min[convolve\[Sigma]f,convolve\[Sigma]g](*2*);

convolvefLimits=NSolve[convolvef==convolvemn*(convolvef/.convolvex->0)(*3*),convolvex];
convolvefLimit=Max[Re[convolvex]/.convolvefLimits];
If[ToString[Head[convolvefLimit]]!="Real"&&ToString[Head[convolvefLimit]]!="Integer"||convolvef!=convolvemn*(convolvef/.convolvex->0),convolvefLimits=FindRoot[convolvef==convolvemn*(convolvef/.convolvex->0)(*3*),{convolvex,convolve\[Sigma]f}];convolvefLimit=Max[Abs[Re[convolvex]]/.convolvefLimits]];
If[ToString[Head[convolvefLimit]]!="Real"&&ToString[Head[convolvefLimit]]!="Integer"||convolvef!=convolvemn*(convolvef/.convolvex->0),convolvefLimits={convolvex->convolvemn0*convolve\[Sigma]f};convolvefLimit=Max[Re[convolvex]/.convolvefLimits]];
convolvegLimits=NSolve[convolveg==convolvemn*(convolveg/.convolvex->0)(*3*),convolvex];
convolvegLimit=Max[Re[convolvex]/.convolvegLimits];
If[ToString[Head[convolvegLimit]]!="Real"&&ToString[Head[convolvegLimit]]!="Integer"||convolveg==convolvemn*(convolveg/.convolvex->0),convolvegLimits=FindRoot[convolveg==convolvemn*(convolveg/.convolvex->0)(*3*),{convolvex,convolve\[Sigma]g}];convolvegLimit=Max[Abs[Re[convolvex]]/.convolvegLimits]];
If[ToString[Head[convolvegLimit]]!="Real"&&ToString[Head[convolvegLimit]]!="Integer"||convolveg==convolvemn*(convolveg/.convolvex->0),convolvegLimits={convolvex->convolvemn0*convolve\[Sigma]g};convolvegLimit=Max[Re[convolvex]/.convolvegLimits]];

convolvefList=Table[(convolvef/.convolvex->convolvexn*convolvestep),{convolvexn,-Ceiling[convolvefLimit/convolvestep],Ceiling[convolvefLimit/convolvestep]}];
convolvegList=Table[(convolveg/.convolvex->convolvexn*convolvestep),{convolvexn,-Ceiling[convolvegLimit/convolvestep],Ceiling[convolvegLimit/convolvestep]}];
If[Length[convolvefList]>Length[convolvegList],convolveLongList=convolvefList;convolveShortList=convolvegList,convolveLongList=convolvegList;convolveShortList=convolvefList];
convolveLongList=Join[Table[0,{Length[convolveShortList]}],convolveLongList,Table[0,{Length[convolveShortList]}]];
convolveht=Interpolation[ListConvolve[convolveShortList,convolveLongList]*convolvestep];
convolveh=convolveht[convolvex/convolvestep+(Length[convolveLongList]-Length[convolveShortList])/2+1];
];
];
Return[{convolveh,convolve\[Sigma]f,convolve\[Sigma]g}];
);
