(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     10159,        273]
NotebookOptionsPosition[      9753,        255]
NotebookOutlinePosition[     10097,        270]
CellTagsIndexPosition[     10054,        267]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"BM\"\>",
   StripOnInput->False,
   FrontFaceColor->RGBColor[1, 0, 0],
   BackFaceColor->RGBColor[1, 0, 0],
   GraphicsColor->RGBColor[1, 0, 0],
   FontSize->24,
   FontWeight->Bold,
   FontColor->RGBColor[1, 0, 0]],
  Appearance->Automatic,
  ButtonFunction:>Quiet[$HistoryLength = 0; Print[
      Style["Programed By Li Ming. IHEP.", Red], 
      Hyperlink[
       Style["Click to mail to me!", Background -> Yellow], 
       "mailto:lim@ihep.ac.cn"]]; Get[
      StringJoin[
       NotebookDirectory[], "/workfunc/162837.tif"]]; $CellContext`BMdata = 
     Import[
       StringJoin[
        NotebookDirectory[], "BM.dat"], "Table", "FieldSeparators" -> "\t"]; 
    Print[
      Grid[$CellContext`BMdata, Frame -> All]]; $CellContext`BMnamea = Part[
       Transpose[
        Drop[$CellContext`BMdata, 1]], 1]; $CellContext`BMdata = Transpose[
       Drop[
        Transpose[
         Drop[$CellContext`BMdata, 1]], 1]]; $CellContext`BMrsta = 
     Map[Apply[$CellContext`BMperformance, #]& , $CellContext`BMdata]; \
$CellContext`style = "color"; Get[
      StringJoin[
       NotebookDirectory[], "/func/loglogplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/logplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/plotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], 
       "/func/tablersts.m"]]; \
$CellContext`loglogplotrsts[$CellContext`BMrsta, {1, 
      26}, $CellContext`BMnamea, $CellContext`style]; \
$CellContext`logplotrsts[$CellContext`BMrsta, {27, 
      28}, $CellContext`BMnamea, $CellContext`style]; \
$CellContext`plotrsts[$CellContext`BMrsta, {27, 
      28}, $CellContext`BMnamea, $CellContext`style]; \
$CellContext`tablersts[$CellContext`BMrsta, {29, 39}, $CellContext`BMnamea]; 
    Print["Finish!"]; Pause[2]; Exit[]; Null],
  Evaluator->Automatic,
  Method->"Queued"]], "Print",
 Editable->False,
 CellChangeTimes->{3.55990708344825*^9, 3.55990885113575*^9}],

Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Wiggler\"\>",
   StripOnInput->False,
   FrontFaceColor->RGBColor[1, 0, 0],
   BackFaceColor->RGBColor[1, 0, 0],
   GraphicsColor->RGBColor[1, 0, 0],
   FontSize->24,
   FontWeight->Bold,
   FontColor->RGBColor[1, 0, 0]],
  Appearance->Automatic,
  ButtonFunction:>Quiet[$HistoryLength = 0; Print[
      Style["Programed By Li Ming. IHEP.", Red], 
      Hyperlink[
       Style["Click to mail to me!", Background -> Yellow], 
       "mailto:lim@ihep.ac.cn"]]; Get[
      StringJoin[
       NotebookDirectory[], "/workfunc/298365.tif"]]; $CellContext`WGLdata = 
     Import[
       StringJoin[
        NotebookDirectory[], "WGL.dat"], "Table", "FieldSeparators" -> "\t"]; 
    Print[
      Grid[$CellContext`WGLdata, Frame -> All]]; $CellContext`WGLnamea = Part[
       Transpose[
        Drop[$CellContext`WGLdata, 1]], 1]; $CellContext`WGLdataT = Drop[
       Transpose[
        Drop[$CellContext`WGLdata, 1]], 1]; $CellContext`WGLdata = Transpose[
       Join[
        Join[
         Part[$CellContext`WGLdataT, 
          Span[1, 14]], {
          ToExpression[
           Part[$CellContext`WGLdataT, 15]]}], {
         ToExpression[
          Part[$CellContext`WGLdataT, 16]]}]]; $CellContext`WGLrsta = 
     Map[Apply[$CellContext`WGLperformance, #]& , $CellContext`WGLdata]; \
$CellContext`style = "color"; Get[
      StringJoin[
       NotebookDirectory[], "/func/logplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/loglogplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/LogPlotrsts0.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/Plotrsts0.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/tablersts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/normloglogplot3D.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/rsts3to2D.m"]]; $CellContext`logplotrsts[
      $CellContext`rsts3to2D[$CellContext`WGLrsta, {1, 2}, 0, {1, 25}], {1, 
      2}, $CellContext`WGLnamea, {
      InterpolationOrder -> 1, $CellContext`style}, 
      401]; $CellContext`loglogplotrsts[$CellContext`WGLrsta, {3, 
      38}, $CellContext`WGLnamea, $CellContext`style]; \
$CellContext`LogPlotrsts[$CellContext`WGLrsta, {40, 
      41}, $CellContext`WGLnamea, $CellContext`style]; \
$CellContext`LogPlotrsts[$CellContext`WGLrsta, {43, 
      44}, $CellContext`WGLnamea, $CellContext`style]; \
$CellContext`Plotrsts[$CellContext`WGLrsta, {40, 
      41}, $CellContext`WGLnamea, $CellContext`style]; \
$CellContext`Plotrsts[$CellContext`WGLrsta, {43, 
      44}, $CellContext`WGLnamea, $CellContext`style]; \
$CellContext`tablersts[$CellContext`WGLrsta, {45, 60}, $CellContext`WGLnamea]; 
    Print["Finish!"]; Pause[2]; Exit[]; Null],
  Evaluator->Automatic,
  Method->"Queued"]], "Print",
 Editable->False,
 CellChangeTimes->{3.55990703457325*^9, 3.559907133542*^9, 
  3.559908867963875*^9}],

Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Undulator\"\>",
   StripOnInput->False,
   FrontFaceColor->RGBColor[1, 0, 0],
   BackFaceColor->RGBColor[1, 0, 0],
   GraphicsColor->RGBColor[1, 0, 0],
   FontSize->24,
   FontWeight->Bold,
   FontColor->RGBColor[1, 0, 0]],
  Appearance->Automatic,
  ButtonFunction:>Quiet[$HistoryLength = 0; Print[
      Style["Programed By Li Ming. IHEP.", Red], 
      Hyperlink[
       Style["Click to mail to me!", Background -> Yellow], 
       "mailto:lim@ihep.ac.cn"]]; Get[
      StringJoin[
       NotebookDirectory[], "/workfunc/387340.tif"]]; $CellContext`UNDLTRdata = 
     Import[
       StringJoin[
        NotebookDirectory[], "UNDLTR.dat"], "Table", "FieldSeparators" -> 
       "\t"]; Print[
      Grid[$CellContext`UNDLTRdata, Frame -> All]]; $CellContext`UNDLTRnamea = 
     Part[
       Transpose[
        Drop[$CellContext`UNDLTRdata, 1]], 1]; $CellContext`UNDLTRdata = 
     Transpose[
       Drop[
        Transpose[
         Drop[$CellContext`UNDLTRdata, 1]], 1]]; $CellContext`UNDLTRrsta = 
     Map[Apply[$CellContext`UNDLTRperformance, #]& , $CellContext`UNDLTRdata]; \
$CellContext`style = "color"; Get[
      StringJoin[
       NotebookDirectory[], "/func/loglogplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/logplotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], "/func/plotrsts.m"]]; Get[
      StringJoin[
       NotebookDirectory[], 
       "/func/tablersts.m"]]; \
$CellContext`loglogplotrsts[$CellContext`UNDLTRrsta, {1, 
      8}, $CellContext`UNDLTRnamea, {
      InterpolationOrder -> 1, $CellContext`style}, 
      401]; $CellContext`loglogplotrsts[$CellContext`UNDLTRrsta, {9, 
      15}, $CellContext`UNDLTRnamea, $CellContext`style]; \
$CellContext`loglogplotrsts[$CellContext`UNDLTRrsta, {16, 
      23}, $CellContext`UNDLTRnamea, {
      InterpolationOrder -> 1, $CellContext`style}, 
      401]; $CellContext`loglogplotrsts[$CellContext`UNDLTRrsta, {24, 
      30}, $CellContext`UNDLTRnamea, $CellContext`style]; \
$CellContext`logplotrsts[$CellContext`UNDLTRrsta, {32, 
      33}, $CellContext`UNDLTRnamea, {
      InterpolationOrder -> 1, $CellContext`style}, 
      401]; $CellContext`logplotrsts[$CellContext`UNDLTRrsta, {35, 
      36}, $CellContext`UNDLTRnamea, {
      InterpolationOrder -> 1, $CellContext`style}, 
      401]; $CellContext`plotrsts[$CellContext`UNDLTRrsta, {32, 
      33}, $CellContext`UNDLTRnamea, $CellContext`style]; \
$CellContext`plotrsts[$CellContext`UNDLTRrsta, {35, 
      36}, $CellContext`UNDLTRnamea, $CellContext`style]; \
$CellContext`tablersts[$CellContext`UNDLTRrsta, {37, 
      53}, $CellContext`UNDLTRnamea]; Print["Finish!"]; Pause[2]; Exit[]; 
    Null],
  Evaluator->Automatic,
  Method->"Queued"]], "Print",
 Editable->False,
 CellChangeTimes->{{3.559907276213875*^9, 3.5599072951045*^9}, 
   3.559907413276375*^9, 3.5599088827295*^9}],

Cell[BoxData[
 ButtonBox[
  StyleBox["\<\"Undulator Optimize\"\>",
   StripOnInput->False,
   FrontFaceColor->RGBColor[1, 0, 0],
   BackFaceColor->RGBColor[1, 0, 0],
   GraphicsColor->RGBColor[1, 0, 0],
   FontSize->24,
   FontWeight->Bold,
   FontColor->RGBColor[1, 0, 0]],
  Appearance->Automatic,
  ButtonFunction:>Quiet[$HistoryLength = 0; Print[
      Style["Programed By Li Ming. IHEP.", Red], 
      Hyperlink[
       Style["Click to mail to me!", Background -> Yellow], 
       "mailto:lim@ihep.ac.cn"]]; Get[
      StringJoin[
       NotebookDirectory[], 
       "/workfunc/439056.tif"]]; $CellContext`OPUNDLTRdata = Import[
       StringJoin[
        NotebookDirectory[], "OPUNDLTR.dat"], "Table", "FieldSeparators" -> 
       "\t"]; Print[
      Grid[$CellContext`OPUNDLTRdata, Frame -> 
       All]]; $CellContext`OPUNDLTRnamea = Part[
       Transpose[
        Drop[$CellContext`OPUNDLTRdata, 1]], 1]; $CellContext`OPUNDLTRdata = 
     Transpose[
       Drop[
        Transpose[
         Drop[$CellContext`OPUNDLTRdata, 1]], 1]]; $CellContext`OPUNDLTRrsta = 
     Map[Apply[$CellContext`UNDLTRoptimize, #]& , $CellContext`OPUNDLTRdata]; 
    Print["Finish!"]; Pause[2]; Exit[]; Null],
  Evaluator->Automatic,
  Method->"Queued"]], "Print",
 Editable->False,
 CellChangeTimes->{{3.559908379167*^9, 3.5599084174795*^9}, 
   3.559908902495125*^9}]
}, Open  ]]
},
WindowSize->{1432, 828},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 1986, 50, 42, "Print"],
Cell[2556, 74, 2923, 70, 42, "Print"],
Cell[5482, 146, 2895, 68, 42, "Print"],
Cell[8380, 216, 1357, 36, 42, "Print"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
